Index: pgadmin/ctl/xh_ctlcolourpicker.cpp
===================================================================
--- pgadmin/ctl/xh_ctlcolourpicker.cpp	(revision 0)
+++ pgadmin/ctl/xh_ctlcolourpicker.cpp	(revision 0)
@@ -0,0 +1,33 @@
+//////////////////////////////////////////////////////////////////////////
+//
+// pgAdmin III - PostgreSQL Tools
+// RCS-ID:      $Id$
+// Copyright (C) 2002 - 2010, The pgAdmin Development Team
+// This software is released under the BSD Licence
+//
+// xh_ctlcolourpicker.cpp - ctlColourPicker handler
+//
+//////////////////////////////////////////////////////////////////////////
+ 
+#include "pgAdmin3.h"
+
+#include "wx/wx.h"
+#include "ctl/ctlColourPicker.h"
+#include "ctl/xh_ctlcolourpicker.h"
+
+IMPLEMENT_DYNAMIC_CLASS(ctlColourPickerXmlHandler, wxBitmapButtonXmlHandler)
+
+
+wxObject *ctlColourPickerXmlHandler::DoCreateResource()
+{ 
+    ctlColourPicker *ctl=new ctlColourPicker(m_parentAsWindow, GetID(), wxNullBitmap);
+    
+    SetupWindow(ctl);
+   
+    return ctl;
+}
+
+bool ctlColourPickerXmlHandler::CanHandle(wxXmlNode *node)
+{
+    return IsOfClass(node, wxT("ctlColourPicker"));
+}
Index: pgadmin/ctl/ctlColourPicker.cpp
===================================================================
--- pgadmin/ctl/ctlColourPicker.cpp	(revision 0)
+++ pgadmin/ctl/ctlColourPicker.cpp	(revision 0)
@@ -0,0 +1,42 @@
+//////////////////////////////////////////////////////////////////////////
+//
+// pgAdmin III - PostgreSQL Tools
+// RCS-ID:      $Id$
+// Copyright (C) 2002 - 2010, The pgAdmin Development Team
+// This software is released under the BSD Licence
+//
+// ctlColourPicker.cpp - Colour Picker with a wxBitmapButton
+//
+//////////////////////////////////////////////////////////////////////////
+
+// wxWindows headers
+#include <wx/wx.h>
+
+// App headers
+#include "pgAdmin3.h"
+#include "ctl/ctlColourPicker.h"
+
+
+/*
+BEGIN_EVENT_TABLE(ctlColourPicker, wxBitmapButton)
+    EVT_BUTTON(ctlColourPicker::OnClick)
+END_EVENT_TABLE()
+*/
+
+
+ctlColourPicker::ctlColourPicker(wxWindow* parent, wxWindowID id, const wxBitmap& bitmap)
+: wxBitmapButton(parent, id, bitmap)
+{
+}
+
+wxColour ctlColourPicker::GetColour()
+{
+}
+
+void ctlColourPicker::SetColour(wxColour colour)
+{
+}
+
+void ctlColourPicker::OnClick(wxCommandEvent &ev)
+{
+}
Index: pgadmin/ctl/module.mk
===================================================================
--- pgadmin/ctl/module.mk	(revision 8203)
+++ pgadmin/ctl/module.mk	(working copy)
@@ -12,6 +12,7 @@
 pgadmin3_SOURCES += \
 	$(srcdir)/ctl/calbox.cpp \
         $(srcdir)/ctl/ctlCheckTreeView.cpp \
+        $(srcdir)/ctl/ctlColourPicker.cpp \
         $(srcdir)/ctl/ctlComboBox.cpp \
         $(srcdir)/ctl/ctlListView.cpp \
         $(srcdir)/ctl/ctlMenuToolbar.cpp \
@@ -28,7 +29,8 @@
         $(srcdir)/ctl/xh_ctlchecktreeview.cpp \
         $(srcdir)/ctl/xh_ctltree.cpp \
         $(srcdir)/ctl/xh_sqlbox.cpp \
-        $(srcdir)/ctl/xh_timespin.cpp
+        $(srcdir)/ctl/xh_timespin.cpp \
+        $(srcdir)/ctl/xh_ctlcolourpicker.cpp
 
 EXTRA_DIST += \
         $(srcdir)/ctl/module.mk
Index: pgadmin/include/ctl/xh_ctlchecktreeview.h
===================================================================
--- pgadmin/include/ctl/xh_ctlchecktreeview.h	(revision 8203)
+++ pgadmin/include/ctl/xh_ctlchecktreeview.h	(working copy)
@@ -5,7 +5,7 @@
 // Copyright (C) 2002 - 2010, The pgAdmin Development Team
 // This software is released under the PostgreSQL Licence
 //
-// xh_ctltree.h - ctlTree handler
+// xh_ctlchecktreeview.h - ctlCheckTreeView handler
 //
 //////////////////////////////////////////////////////////////////////////
 
Index: pgadmin/include/ctl/xh_ctlcolourpicker.h
===================================================================
--- pgadmin/include/ctl/xh_ctlcolourpicker.h	(revision 0)
+++ pgadmin/include/ctl/xh_ctlcolourpicker.h	(revision 0)
@@ -0,0 +1,31 @@
+//////////////////////////////////////////////////////////////////////////
+//
+// pgAdmin III - PostgreSQL Tools
+// RCS-ID:      $Id$
+// Copyright (C) 2002 - 2010, The pgAdmin Development Team
+// This software is released under the BSD Licence
+//
+// xh_ctlcolourpicker.h - ctlColourPicker handler
+//
+//////////////////////////////////////////////////////////////////////////
+
+
+#ifndef _WX_XH_CTLCOLOURPICKER_H_
+#define _WX_XH_CTLCOLOURPICKER_H_
+
+
+#include "wx/xrc/xmlres.h"
+#include "wx/xrc/xh_bmpbt.h"
+
+//class WXDLLIMPEXP_XRC 
+class ctlColourPickerXmlHandler : public wxBitmapButtonXmlHandler
+{
+DECLARE_DYNAMIC_CLASS(ctlColourPickerXmlHandler)
+public:
+    ctlColourPickerXmlHandler() : wxBitmapButtonXmlHandler() {}
+    virtual wxObject *DoCreateResource();
+    virtual bool CanHandle(wxXmlNode *node);
+};
+
+
+#endif 
Index: pgadmin/include/ctl/ctlColourPicker.h
===================================================================
--- pgadmin/include/ctl/ctlColourPicker.h	(revision 0)
+++ pgadmin/include/ctl/ctlColourPicker.h	(revision 0)
@@ -0,0 +1,34 @@
+//////////////////////////////////////////////////////////////////////////
+//
+// pgAdmin III - PostgreSQL Tools
+// RCS-ID:      $Id$
+// Copyright (C) 2002 - 2010, The pgAdmin Development Team
+// This software is released under the BSD Licence
+//
+// ctlColourPicker.cpp - TreeView with Checkboxes
+//
+//////////////////////////////////////////////////////////////////////////
+
+
+#ifndef _CTLCOLOURPICKER_H
+#define _CTLCOLOURPICKER_H
+
+// wxWindows headers
+#include <wx/wx.h>
+#include "utils/misc.h"
+
+
+
+class ctlColourPicker : public wxBitmapButton
+{
+public:
+    ctlColourPicker(wxWindow* parent, wxWindowID id, const wxBitmap& bitmap);
+
+    wxColour GetColour();
+    void SetColour(wxColour colour);
+
+private:
+    void OnClick(wxCommandEvent &evt);
+};
+
+#endif
Index: pgadmin/include/ctl/module.mk
===================================================================
--- pgadmin/include/ctl/module.mk	(revision 8203)
+++ pgadmin/include/ctl/module.mk	(working copy)
@@ -12,6 +12,7 @@
 pgadmin3_SOURCES += \
     $(srcdir)/include/ctl/calbox.h \
 	$(srcdir)/include/ctl/ctlCheckTreeView.h \
+    $(srcdir)/include/ctl/ctlColourPicker.h \
 	$(srcdir)/include/ctl/ctlComboBox.h \
 	$(srcdir)/include/ctl/ctlListView.h \
 	$(srcdir)/include/ctl/ctlMenuToolbar.h \
Index: pgadmin/include/pgAdmin3.h
===================================================================
--- pgadmin/include/pgAdmin3.h	(revision 8203)
+++ pgadmin/include/pgAdmin3.h	(working copy)
@@ -24,6 +24,7 @@
 #include "ctl/ctlListView.h"
 #include "ctl/ctlComboBox.h"
 #include <ctl/ctlCheckTreeView.h>
+#include <ctl/ctlColourPicker.h>
 #include "dlg/dlgClasses.h"
 #include "db/pgConn.h"
 #include "db/pgSet.h"
Index: pgadmin/include/precomp.h
===================================================================
--- pgadmin/include/precomp.h	(revision 8203)
+++ pgadmin/include/precomp.h	(working copy)
@@ -24,6 +24,7 @@
 
 #include "ctl/calbox.h"
 #include "ctl/ctlCheckTreeView.h"
+#include "ctl/ctlColourPicker.h"
 #include "ctl/ctlComboBox.h"
 #include "ctl/ctlListView.h"
 #include "ctl/ctlSecurityPanel.h"
@@ -37,6 +38,7 @@
 #include "ctl/xh_calb.h"
 #include "ctl/xh_ctlcombo.h"
 #include "ctl/xh_ctlchecktreeview.h"
+#include "ctl/xh_ctlcolourpicker.h"
 #include "ctl/xh_ctltree.h"
 #include "ctl/xh_sqlbox.h"
 #include "ctl/xh_timespin.h"
Index: pgadmin/include/utils/misc.h
===================================================================
--- pgadmin/include/utils/misc.h	(revision 8203)
+++ pgadmin/include/utils/misc.h	(working copy)
@@ -87,7 +87,7 @@
 #define CTRL_CHECKLISTBOX(id)   (XRCCTRL(*this, id, wxCheckListBox))
 #define CTRL_DATEPICK(id)       (XRCCTRL(*this, id, wxDatePickerCtrl))
 #define CTRL_TREE(id)           (XRCCTRL(*this, id, ctlTree))
-#define CTRL_COLOURPICKER(id)   (XRCCTRL(*this, id, wxColourPickerCtrl))
+#define CTRL_COLOURPICKER(id)   (XRCCTRL(*this, id, ctlColourPicker))
 #define CTRL_CHECKTREEVIEW(id)  (XRCCTRL(*this, id, ctlCheckTreeView))
 
 #endif // PGSCLI
Index: pgadmin/pgAdmin3.cpp
===================================================================
--- pgadmin/pgAdmin3.cpp	(revision 8203)
+++ pgadmin/pgAdmin3.cpp	(working copy)
@@ -66,6 +66,7 @@
 #include "ctl/xh_ctlcombo.h"
 #include "ctl/xh_ctltree.h"
 #include "ctl/xh_ctlchecktreeview.h"
+#include "ctl/xh_ctlcolourpicker.h"
 
 #define DOC_DIR       wxT("/docs")
 #define UI_DIR        wxT("/ui")
@@ -379,6 +380,7 @@
     wxXmlResource::Get()->AddHandler(new ctlComboBoxXmlHandler);
     wxXmlResource::Get()->AddHandler(new ctlTreeXmlHandler);
     wxXmlResource::Get()->AddHandler(new ctlCheckTreeViewXmlHandler);
+    wxXmlResource::Get()->AddHandler(new ctlColourPickerXmlHandler);
 
     InitXml();
 