diff --git a/pgadmin/ctl/ctlComboBox.cpp b/pgadmin/ctl/ctlComboBox.cpp
index bebf242..88fcdbd 100644
--- a/pgadmin/ctl/ctlComboBox.cpp
+++ b/pgadmin/ctl/ctlComboBox.cpp
@@ -96,21 +96,21 @@ long ctlComboBoxFix::GetLongKey(int sel)
 {
 	if (sel < 0)
 		sel = GetSelection();
-	return (long)GetClientData(sel);
+	return (long)wxItemContainer::GetClientData(sel);
 }
 
 OID ctlComboBoxFix::GetOIDKey(int sel)
 {
 	if (sel < 0)
 		sel = GetSelection();
-	return (OID)GetClientData(sel);
+	return (OID)wxItemContainer::GetClientData(sel);
 }
 
 wxString ctlComboBoxFix::GetStringKey(int sel)
 {
 	if (sel < 0)
 		sel = GetSelection();
-	StringClientData *scd = (StringClientData *)GetClientObject(sel);
+	StringClientData *scd = (StringClientData *)wxItemContainer::GetClientObject(sel);
 	if (scd)
 		return scd->str;
 	return wxEmptyString;
diff --git a/pgadmin/dlg/dlgDatabase.cpp b/pgadmin/dlg/dlgDatabase.cpp
index f9502d1..b053e64 100644
--- a/pgadmin/dlg/dlgDatabase.cpp
+++ b/pgadmin/dlg/dlgDatabase.cpp
@@ -422,7 +422,7 @@ bool dlgDatabase::executeDDLSql(const wxString &strSql)
 		wxString tmp;
 		if (cbClusterSet && cbClusterSet->GetSelection() > 0)
 		{
-			replClientData *data = (replClientData *)cbClusterSet->GetClientData(cbClusterSet->GetSelection());
+			replClientData *data = (replClientData *)cbClusterSet->wxItemContainer::GetClientData(cbClusterSet->GetSelection());
 
 			if (data->majorVer > 1 || (data->majorVer == 1 && data->minorVer >= 2))
 			{
diff --git a/pgadmin/dlg/dlgProperty.cpp b/pgadmin/dlg/dlgProperty.cpp
index c02abff..1d70348 100644
--- a/pgadmin/dlg/dlgProperty.cpp
+++ b/pgadmin/dlg/dlgProperty.cpp
@@ -647,7 +647,7 @@ void dlgProperty::FillSQLTextfield()
 		wxString tmp;
 		if (cbClusterSet && cbClusterSet->GetSelection() > 0)
 		{
-			replClientData *data = (replClientData *)cbClusterSet->GetClientData(cbClusterSet->GetSelection());
+			replClientData *data = (replClientData *)cbClusterSet->wxItemContainer::GetClientData(cbClusterSet->GetSelection());
 			tmp.Printf(_("-- Execute replicated using cluster \"%s\", set %ld\n"), data->cluster.c_str(), data->setId);
 		}
 		sqlTextField1->SetText(tmp + GetSql());
@@ -867,7 +867,7 @@ wxString dlgProperty::BuildSql(const wxString &sql)
 
 	if (cbClusterSet && cbClusterSet->GetSelection() > 0)
 	{
-		replClientData *data = (replClientData *)cbClusterSet->GetClientData(cbClusterSet->GetSelection());
+		replClientData *data = (replClientData *)cbClusterSet->wxItemContainer::GetClientData(cbClusterSet->GetSelection());
 
 		if (data->majorVer > 1 || (data->majorVer == 1 && data->minorVer >= 2))
 		{
diff --git a/pgadmin/dlg/dlgSelectConnection.cpp b/pgadmin/dlg/dlgSelectConnection.cpp
index 137b403..d3a79dd 100644
--- a/pgadmin/dlg/dlgSelectConnection.cpp
+++ b/pgadmin/dlg/dlgSelectConnection.cpp
@@ -105,7 +105,7 @@ void dlgSelectConnection::OnChangeServer(wxCommandEvent &ev)
 	int sel = cbServer->GetCurrentSelection();
 	if (sel >= 0)
 	{
-		remoteServer = (pgServer *)cbServer->GetClientData(sel);
+		remoteServer = (pgServer *)cbServer->wxItemContainer::GetClientData(sel);
 
 		if (!remoteServer->GetConnected())
 		{
diff --git a/pgadmin/frm/frmOptions.cpp b/pgadmin/frm/frmOptions.cpp
index ec30ca7..240e22b 100644
--- a/pgadmin/frm/frmOptions.cpp
+++ b/pgadmin/frm/frmOptions.cpp
@@ -120,6 +120,7 @@ END_EVENT_TABLE()
 // Mac OS X Snow Leopard
 //----------------------------------------------------------------------------
 
+#if !wxCHECK_VERSION(2, 9, 0)
 #ifdef __WXMAC__
 
 #include <wx/fontdlg.h>
@@ -200,6 +201,7 @@ int wxRichTextFontDialog::ShowModal()
 }
 
 #endif
+#endif
 
 //----------------------------------------------------------------------------
 
diff --git a/pgadmin/frm/frmStatus.cpp b/pgadmin/frm/frmStatus.cpp
index b9fb883..6180ac5 100644
--- a/pgadmin/frm/frmStatus.cpp
+++ b/pgadmin/frm/frmStatus.cpp
@@ -1693,7 +1693,7 @@ void frmStatus::OnRefreshLogTimer(wxTimerEvent &event)
 			while (newfiles--)
 			{
 				addLogLine(_("pgadmin:Logfile rotated."), false);
-				wxDateTime *ts = (wxDateTime *)cbLogfiles->GetClientData(pos++);
+				wxDateTime *ts = (wxDateTime *)cbLogfiles->wxItemContainer::GetClientData(pos++);
 				wxASSERT(ts != 0);
 
 				addLogFile(ts, skipFirst);
@@ -2264,7 +2264,7 @@ void frmStatus::emptyLogfileCombo()
 
 	while (cbLogfiles->GetCount())
 	{
-		wxDateTime *dt = (wxDateTime *)cbLogfiles->GetClientData(0);
+		wxDateTime *dt = (wxDateTime *)cbLogfiles->wxItemContainer::GetClientData(0);
 		if (dt)
 			delete dt;
 		cbLogfiles->Delete(0);
@@ -2322,7 +2322,7 @@ void frmStatus::OnLoadLogfile(wxCommandEvent &event)
 		showCurrent = (pos == 0);
 		isCurrent = showCurrent || (pos == lastPos);
 
-		wxDateTime *ts = (wxDateTime *)cbLogfiles->GetClientData(showCurrent ? lastPos : pos);
+		wxDateTime *ts = (wxDateTime *)cbLogfiles->wxItemContainer::GetClientData(showCurrent ? lastPos : pos);
 		wxASSERT(ts != 0);
 
 		if (ts != NULL && (!logfileTimestamp.IsValid() || *ts != logfileTimestamp))
diff --git a/pgadmin/slony/dlgRepCluster.cpp b/pgadmin/slony/dlgRepCluster.cpp
index 480c0db..3c72c26 100644
--- a/pgadmin/slony/dlgRepCluster.cpp
+++ b/pgadmin/slony/dlgRepCluster.cpp
@@ -113,7 +113,7 @@ void dlgRepClusterBase::OnChangeServer(wxCommandEvent &ev)
 	int sel = cbServer->GetCurrentSelection();
 	if (sel >= 0)
 	{
-		remoteServer = (pgServer *)cbServer->GetClientData(sel);
+		remoteServer = (pgServer *)cbServer->wxItemContainer::GetClientData(sel);
 
 		if (!remoteServer->GetConnected())
 		{
@@ -754,7 +754,7 @@ void dlgRepCluster::OnOK(wxCommandEvent &ev)
 			done = remoteConn->ExecuteVoid(
 			           wxT("SELECT ") + schemaPrefix + wxT("storepath(") +
 			           txtNodeID->GetValue() + wxT(", ") +
-			           NumToStr((long)cbAdminNode->GetClientData(cbAdminNode->GetCurrentSelection())) + wxT(", ") +
+			           NumToStr((long)cbAdminNode->wxItemContainer::GetClientData(cbAdminNode->GetCurrentSelection())) + wxT(", ") +
 			           qtDbString(wxT("host=") + database->GetServer()->GetName() +
 			                      wxT(" port=") + NumToStr((long)database->GetServer()->GetPort()) +
 			                      wxT(" dbname=") + database->GetName()) + wxT(", ")
@@ -793,7 +793,7 @@ void dlgRepCluster::CheckChange()
 	if (cluster)
 	{
 		int sel = cbAdminNode->GetCurrentSelection();
-		bool changed = (sel >= 0 && (long)cbAdminNode->GetClientData() != cluster->GetAdminNodeID());
+		bool changed = (sel >= 0 && (long)cbAdminNode->wxItemContainer::GetClientData(sel) != cluster->GetAdminNodeID());
 
 		EnableOK(changed || txtComment->GetValue() != cluster->GetComment());
 	}
@@ -902,7 +902,7 @@ wxString dlgRepCluster::GetSql()
 		int sel = cbAdminNode->GetCurrentSelection();
 		if (sel >= 0)
 		{
-			long id = (long)cbAdminNode->GetClientData(sel);
+			long id = (long)cbAdminNode->wxItemContainer::GetClientData(sel);
 			if (id != cluster->GetAdminNodeID())
 				settings->WriteLong(wxT("Replication/") + cluster->GetName() + wxT("/AdminNode"), id);
 		}
diff --git a/pgadmin/slony/dlgRepListen.cpp b/pgadmin/slony/dlgRepListen.cpp
index 07c672d..5c2e48d 100644
--- a/pgadmin/slony/dlgRepListen.cpp
+++ b/pgadmin/slony/dlgRepListen.cpp
@@ -108,9 +108,9 @@ int dlgRepListen::Go(bool modal)
 pgObject *dlgRepListen::CreateObject(pgCollection *collection)
 {
 	pgObject *obj = listenFactory.CreateObjects(collection, 0,
-	                wxT(" WHERE li_origin = ") + NumToStr((OID)cbOrigin->GetClientData(cbOrigin->GetCurrentSelection())) +
+	                wxT(" WHERE li_origin = ") + NumToStr((OID)cbOrigin->wxItemContainer::GetClientData(cbOrigin->GetCurrentSelection())) +
 	                wxT("   AND li_receiver = ") + NumToStr(node->GetSlId()) +
-	                wxT("   AND li_provider = ") + NumToStr((OID)cbProvider->GetClientData(cbProvider->GetCurrentSelection()))
+	                wxT("   AND li_provider = ") + NumToStr((OID)cbProvider->wxItemContainer::GetClientData(cbProvider->GetCurrentSelection()))
 	                                           );
 
 	return obj;
@@ -150,8 +150,8 @@ wxString dlgRepListen::GetSql()
 		// create mode
 
 		sql = wxT("SELECT ") + cluster->GetSchemaPrefix() + wxT("storelisten(")
-		      + NumToStr((OID)cbOrigin->GetClientData(cbOrigin->GetCurrentSelection())) + wxT(", ")
-		      + NumToStr((OID)cbProvider->GetClientData(cbProvider->GetCurrentSelection())) + wxT(", ")
+		      + NumToStr((OID)cbOrigin->wxItemContainer::GetClientData(cbOrigin->GetCurrentSelection())) + wxT(", ")
+		      + NumToStr((OID)cbProvider->wxItemContainer::GetClientData(cbProvider->GetCurrentSelection())) + wxT(", ")
 		      + NumToStr(node->GetSlId()) + wxT(");");
 	}
 
diff --git a/pgadmin/slony/dlgRepPath.cpp b/pgadmin/slony/dlgRepPath.cpp
index 03298f1..5fb4f2f 100644
--- a/pgadmin/slony/dlgRepPath.cpp
+++ b/pgadmin/slony/dlgRepPath.cpp
@@ -103,7 +103,7 @@ int dlgRepPath::Go(bool modal)
 pgObject *dlgRepPath::CreateObject(pgCollection *collection)
 {
 	pgObject *obj = pathFactory.CreateObjects(collection, 0,
-	                wxT(" WHERE pa_server = ") + NumToStr((OID)cbServer->GetClientData(cbServer->GetCurrentSelection())) +
+	                wxT(" WHERE pa_server = ") + NumToStr((OID)cbServer->wxItemContainer::GetClientData(cbServer->GetCurrentSelection())) +
 	                wxT("   AND pa_client = ") + NumToStr(node->GetSlId()));
 
 	return obj;
@@ -145,7 +145,7 @@ wxString dlgRepPath::GetSql()
 	if (sel >= 0)
 	{
 		sql = wxT("SELECT ") + cluster->GetSchemaPrefix() + wxT("storepath(")
-		      + NumToStr((OID)cbServer->GetClientData(sel)) + wxT(", ")
+		      + NumToStr((OID)cbServer->wxItemContainer::GetClientData(sel)) + wxT(", ")
 		      + NumToStr(node->GetSlId()) + wxT(", ")
 		      + qtDbString(txtConnInfo->GetValue()) + wxT(", ")
 		      + NumToStr(StrToLong(txtConnRetry->GetValue())) + wxT(");");
diff --git a/pgadmin/slony/dlgRepSequence.cpp b/pgadmin/slony/dlgRepSequence.cpp
index 3798138..a948fa5 100644
--- a/pgadmin/slony/dlgRepSequence.cpp
+++ b/pgadmin/slony/dlgRepSequence.cpp
@@ -107,7 +107,7 @@ int dlgRepSequence::Go(bool modal)
 pgObject *dlgRepSequence::CreateObject(pgCollection *collection)
 {
 	pgObject *obj = slSequenceFactory.CreateObjects(collection, 0,
-	                wxT(" WHERE seq_reloid = ") + NumToStr((OID)cbSequence->GetClientData(cbSequence->GetGuessedSelection())));
+	                wxT(" WHERE seq_reloid = ") + NumToStr((OID)cbSequence->wxItemContainer::GetClientData(cbSequence->GetGuessedSelection())));
 
 	return obj;
 }
diff --git a/pgadmin/slony/dlgRepSet.cpp b/pgadmin/slony/dlgRepSet.cpp
index 66e8235..f22b4bb 100644
--- a/pgadmin/slony/dlgRepSet.cpp
+++ b/pgadmin/slony/dlgRepSet.cpp
@@ -188,7 +188,7 @@ wxString dlgRepSetMerge::GetSql()
 {
 	wxString sql;
 	wxString addId = NumToStr(set->GetSlId());
-	wxString toId = NumToStr((long)cbTargetID->GetClientData(cbTargetID->GetCurrentSelection()));
+	wxString toId = NumToStr((long)cbTargetID->wxItemContainer::wxItemContainer::GetClientData(cbTargetID->GetCurrentSelection()));
 	wxString prefix = cluster->GetSchemaPrefix();
 
 	if (set->GetSubscriptionCount() > 0)
@@ -301,7 +301,7 @@ void dlgRepSetMove::CheckChange()
 
 wxString dlgRepSetMove::GetSql()
 {
-	wxString toId = NumToStr((long)cbTargetNode->GetClientData(cbTargetNode->GetCurrentSelection()));
+	wxString toId = NumToStr((long)cbTargetNode->wxItemContainer::wxItemContainer::GetClientData(cbTargetNode->GetCurrentSelection()));
 
 	wxString sql =
 	    wxT("SELECT ") + cluster->GetSchemaPrefix() + wxT("moveset(") +
diff --git a/pgadmin/slony/dlgRepSubscription.cpp b/pgadmin/slony/dlgRepSubscription.cpp
index 30d9c2c..ff17bef 100644
--- a/pgadmin/slony/dlgRepSubscription.cpp
+++ b/pgadmin/slony/dlgRepSubscription.cpp
@@ -136,7 +136,7 @@ void dlgRepSubscription::CheckChange()
 		int sel = cbProvider->GetCurrentSelection();
 
 		EnableOK(sel >= 0 && (chkForward->GetValue() != subscription->GetForward()
-		                      ||   (long)cbProvider->GetClientData(sel) != subscription->GetProviderId()));
+		                      ||   (long)cbProvider->wxItemContainer::GetClientData(sel) != subscription->GetProviderId()));
 	}
 	else
 	{
@@ -159,11 +159,11 @@ wxString dlgRepSubscription::GetSql()
 	{
 		// Actually, provider and receiver are exchanged here.
 		sql += NumToStr(cluster->GetLocalNodeID()) + wxT(", ")
-		       + NumToStr((long)cbProvider->GetClientData(cbProvider->GetCurrentSelection()));
+		       + NumToStr((long)cbProvider->wxItemContainer::GetClientData(cbProvider->GetCurrentSelection()));
 	}
 	else
 	{
-		sql += NumToStr((long)cbProvider->GetClientData(cbProvider->GetCurrentSelection())) + wxT(", ")
+		sql += NumToStr((long)cbProvider->wxItemContainer::GetClientData(cbProvider->GetCurrentSelection())) + wxT(", ")
 		       + NumToStr(cluster->GetLocalNodeID());
 	}
 	sql += wxT(", ")
diff --git a/pgadmin/slony/dlgRepTable.cpp b/pgadmin/slony/dlgRepTable.cpp
index c7368e5..22ee375 100644
--- a/pgadmin/slony/dlgRepTable.cpp
+++ b/pgadmin/slony/dlgRepTable.cpp
@@ -124,7 +124,7 @@ int dlgRepTable::Go(bool modal)
 pgObject *dlgRepTable::CreateObject(pgCollection *collection)
 {
 	pgObject *obj = slTableFactory.CreateObjects(collection, 0,
-	                wxT(" WHERE tab_reloid = ") + NumToStr((OID)cbTable->GetClientData(cbTable->GetGuessedSelection())));
+	                wxT(" WHERE tab_reloid = ") + NumToStr((OID)cbTable->wxItemContainer::GetClientData(cbTable->GetGuessedSelection())));
 
 	return obj;
 }
@@ -147,7 +147,7 @@ void dlgRepTable::OnChangeTable(wxCommandEvent &ev)
 
 	if (sel >= 0)
 	{
-		OID relid = (OID)cbTable->GetClientData(sel);
+		OID relid = (OID)cbTable->wxItemContainer::GetClientData(sel);
 
 		pgSet *idx = connection->ExecuteSet(
 		                 wxT("SELECT relname\n")
diff --git a/pgadmin/ui/dlgConnect.xrc b/pgadmin/ui/dlgConnect.xrc
index b80ee2f..121c2a2 100644
--- a/pgadmin/ui/dlgConnect.xrc
+++ b/pgadmin/ui/dlgConnect.xrc
@@ -3,7 +3,7 @@
   <object class="wxDialog" name="dlgConnect">
     <title>Connect to Server</title>
     <size>205,83d</size>
-    <style>wxDEFAULT_DIALOG_STYLE|wxDIALOG_MODAL|wxCAPTION|wxSYSTEM_MENU|wxRESIZE_BORDER</style>
+    <style>wxDEFAULT_DIALOG_STYLE|wxCAPTION|wxSYSTEM_MENU|wxRESIZE_BORDER</style>
     <object class="wxFlexGridSizer">
       <cols>1</cols>
       <rows>5</rows>
diff --git a/pgadmin/ui/dlgSelectConnection.xrc b/pgadmin/ui/dlgSelectConnection.xrc
index 2a22ccc..0424936 100644
--- a/pgadmin/ui/dlgSelectConnection.xrc
+++ b/pgadmin/ui/dlgSelectConnection.xrc
@@ -3,7 +3,7 @@
   <object class="wxDialog" name="dlgSelectConnection">
     <title>Connect to Server</title>
     <size>205,98d</size>
-    <style>wxDEFAULT_DIALOG_STYLE|wxDIALOG_MODAL|wxCAPTION|wxSYSTEM_MENU</style>
+    <style>wxDEFAULT_DIALOG_STYLE|wxCAPTION|wxSYSTEM_MENU</style>
     <object class="wxStaticText" name="stServer">
       <label>Server</label>
       <pos>5,7d</pos>
diff --git a/pgadmin/ui/frmPassword.xrc b/pgadmin/ui/frmPassword.xrc
index 499b072..5c6cf39 100644
--- a/pgadmin/ui/frmPassword.xrc
+++ b/pgadmin/ui/frmPassword.xrc
@@ -3,7 +3,7 @@
   <object class="wxDialog" name="frmPassword">
     <title>Change Password</title>
     <size>175,73d</size>
-    <style>wxDEFAULT_DIALOG_STYLE|wxDIALOG_MODAL|wxCAPTION|wxSYSTEM_MENU</style>
+    <style>wxDEFAULT_DIALOG_STYLE|wxCAPTION|wxSYSTEM_MENU</style>
     <object class="wxStaticText" name="lblCurrent">
       <label>Current Password</label>
       <pos>5,7d</pos>
@@ -44,4 +44,4 @@
       <pos>120,55d</pos>
     </object>
   </object>
-</resource>
\ No newline at end of file
+</resource>